! aiMailMerge Class by Lars Bevik, Aileron AB, lars.bevik@aileron.se

  member()
  include('aimailmerge.inc')
  map
    module('XmlMailMerge.dll')
      XmlMailMerge(*cstring),pascal,raw,name('XmlMailMerge'),dll(1)
    end
  end

!------------------------------------------------------------------------------
aiMailMergeClass.Init procedure(long buflen)
!------------------------------------------------------------------------------
! Create string buffer to pass to aiMailMerge procedure

  code
  if ~Self.XmlString &= NULL
    Self.XmlString &= NULL
  end
  Self.XmlString &= new cstring(buflen)
  clear(Self.XmlString)


!------------------------------------------------------------------------------
aiMailMergeClass.Kill procedure
!------------------------------------------------------------------------------

  code
  Self.XmlString &= NULL

!------------------------------------------------------------------------------
aiMailMergeClass.BeginXML procedure(string TemplateName,string Encoding)
!------------------------------------------------------------------------------

  code
  clear(Self.Xmlstring)
  if len(clip(Encoding))
    Self.AddToXmlString('<<?xml version="1.0" encoding="' & clip(Encoding) & '"?><13,10>')
  else
    Self.AddToXmlString('<<?xml version="1.0" ?><13,10>')
  end
  Self.AddToXmlString('<<root><13,10>')
  Self.AddToXmlString('  <<template filename="' & clip(TemplateName) & '" /><13,10>')
  Self.AddToXmlString('  <<window title="' & clip(Self.WinTitle) & '" text="' & |
   clip(Self.WinText) & '" /><13,10>')


!------------------------------------------------------------------------------
aiMailMergeClass.EndXML procedure
!------------------------------------------------------------------------------

  code
  Self.AddToXmlString('<</root><13,10>')


!------------------------------------------------------------------------------
aiMailMergeClass.BeginFields procedure
!------------------------------------------------------------------------------

  code
  Self.AddToXmlString('  <<fields><13,10>')


!------------------------------------------------------------------------------
aiMailMergeClass.EndFields procedure
!------------------------------------------------------------------------------

  code
  Self.AddToXmlString('  <</fields><13,10>')


!------------------------------------------------------------------------------
aiMailMergeClass.BeginData procedure
!------------------------------------------------------------------------------

  code
  Self.AddToXmlString('  <<data><13,10>')


!------------------------------------------------------------------------------
aiMailMergeClass.EndData procedure
!------------------------------------------------------------------------------

  code
  Self.AddToXmlString('  <</data><13,10>')


!------------------------------------------------------------------------------
aiMailMergeClass.AddField procedure(string Name,byte Type,short Width)
!------------------------------------------------------------------------------

FType       string(6)
sTemp       string(80)

  code
  execute Type
    FType = 'string'
    FType = 'integer'
    FType = 'real'
  end
  Self.AddToXmlString('    <<field name="' & clip(Name) & '" fieldtype="' & |
   clip(FType) & '" width="' & Width & '" /><13,10>')


!------------------------------------------------------------------------------
aiMailMergeClass.AddFieldsFromQue procedure(*queue Que)
!------------------------------------------------------------------------------

i       short
j       short
Fvalue  any
Fname   string(80)

  code
  Self.AddToXmlString('    <<record')
  loop
    j += 1
    if who(Que,j) = '' then break.
    Fvalue = what(Que,j)
    Fname = lower(who(Que,j))
    Self.AddToXmlString(' ' & clip(Fname) & '="' & clip(FValue) & '"')
  end
  Self.AddToXmlString(' /><13,10>')


!------------------------------------------------------------------------------
aiMailMergeClass.AddToXmlString procedure(string s)
!------------------------------------------------------------------------------

  code
  Self.XmlString = clip(Self.XmlString) & clip(s)


!------------------------------------------------------------------------------
aiMailMergeClass.Activate procedure
!------------------------------------------------------------------------------

  code
  Self.AddToXmlString('<</root><13,10>')
  XmlMailMerge(Self.XmlString)

